"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UserAgentUI = void 0;
function _ui() {
  const data = require("@teambit/ui");
  _ui = function () {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _uaParserJs() {
  const data = _interopRequireDefault(require("ua-parser-js"));
  _uaParserJs = function () {
    return data;
  };
  return data;
}
function _uiFoundationUiHooks() {
  const data = require("@teambit/ui-foundation.ui.hooks.use-user-agent");
  _uiFoundationUiHooks = function () {
    return data;
  };
  return data;
}
function _userAgent() {
  const data = require("./user-agent.aspect");
  _userAgent = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * user agent aspect
 */
class UserAgentUI {
  static async provider([uiUi]) {
    const userAgentUi = new UserAgentUI();
    uiUi.registerRenderHooks({
      serverInit: ({
        browser
      }) => {
        const userAgent = new (_uaParserJs().default)(browser.headers['user-agent']);
        return {
          userAgent
        };
      },
      browserInit: () => {
        return {
          userAgent: new (_uaParserJs().default)(window.navigator.userAgent)
        };
      },
      reactContext: UserAgentReactContext
    });
    return userAgentUi;
  }
}
exports.UserAgentUI = UserAgentUI;
_defineProperty(UserAgentUI, "slots", []);
_defineProperty(UserAgentUI, "dependencies", [_ui().UIAspect]);
_defineProperty(UserAgentUI, "runtime", _ui().UIRuntime);
function UserAgentReactContext({
  children,
  renderCtx
}) {
  // @todo - UserAgentProvider needs to be explicitly typed
  return /*#__PURE__*/_react().default.createElement(_uiFoundationUiHooks().UserAgentProvider, {
    value: renderCtx?.userAgent
  }, children);
}
_userAgent().UserAgentAspect.addRuntime(UserAgentUI);

//# sourceMappingURL=user-agent.ui.runtime.js.map